// includes //
#include <windows.h>
#include "resource.h"
#include "myrt.h"

/* MEMO *
IOCTL_SERIAL

ʃR}hAl
OK = 0x06
NG = 0x08?0x18Ȃ
A肪2oCgȏ̎0x06𑗐MȂႢȂۂB(@擾Ƃ)
ʐMI0x04𑗐MClose.
* MEMO END */

// GlobalDefine //
HWND hMainWnd;

// Useful serial functions //
BOOL Write(HANDLE hFile, LPCVOID ptr, DWORD byte)
{
	DWORD bytes;
	DWORD tick;
	DWORD wrote = 0;

	tick = GetTickCount();

	while(wrote < byte)
	{
		WriteFile(hFile, (char*)ptr + wrote, byte - wrote, &bytes, NULL);
		wrote += bytes;
		if((tick + 5000) < GetTickCount())	// TIMEOUT!!
			return TRUE;
	}

	return FALSE;
}

BOOL WriteByte(HANDLE hFile, BYTE byte)
{
	return Write(hFile, &byte, 1);
}

BOOL Read(HANDLE hFile, LPVOID ptr, DWORD byte)
{
	DWORD bytes;
	DWORD read = 0;
	DWORD tick;

	tick = GetTickCount();

	while(read < byte)
	{
		ReadFile(hFile, (char*)ptr + read, byte - read, &bytes, NULL);
		read += bytes;
		if((tick + 5000) < GetTickCount())	// TIMEOUT!!
			return TRUE;
	}

	return FALSE;
}

WORD ReadByte(HANDLE hFile)
{
	BYTE ret;

	if(Read(hFile, &ret, 1))
		return 0x0100;

	return (WORD)ret;
}

BOOL sendCommand(HANDLE hFile, LPVOID ptr, DWORD byte)
{
	unsigned char tmp[4];
	unsigned short sum = 0xFFFF;
	DWORD i;

	tmp[0] = 0x01;
	tmp[1] = 0x00;
	tmp[2] = (unsigned char)((byte + 3) >> 8) & 0xFF;
	tmp[3] = (unsigned char)(byte + 3) & 0xFF;
	if(Write(hFile, tmp, 4))
		return TRUE;	// head send failed
	for(i = 0; i < 4; i++)
		sum -= tmp[i];

	if(Write(hFile, ptr, byte))
		return TRUE;	// data send failed

	for(i = 0; i < byte; i++)
		sum -= ((unsigned char*)ptr)[i];

	sum -= 3;

	tmp[0] = 0x03;
	tmp[1] = (unsigned char)(sum >> 8) & 0xFF;
	tmp[2] = (unsigned char)sum & 0xFF;
	if(Write(hFile, tmp, 3))
		return TRUE;	// foot send failed

	return FALSE;
}

char* getResult(HANDLE hCom)
{
	return NULL;
}

int GetDlgItemTextLength(HWND hDlg, int nIDDlgItem)
{
	return GetWindowTextLength(GetDlgItem(hDlg, nIDDlgItem));
}

void Log(LPCSTR str)
{
	char* buf;
	DWORD len;

	len = GetDlgItemTextLength(hMainWnd, IDC_DEBUG) + strlength(str) + 1;
	if(!(buf = halloc(len)))
		return;
	GetDlgItemText(hMainWnd, IDC_DEBUG, buf, len);
	strplus(buf, str);
	SetDlgItemText(hMainWnd, IDC_DEBUG, buf);
	hfree(buf);

	SendMessage(GetDlgItem(hMainWnd, IDC_DEBUG), EM_SETSEL, len, len);
	SendMessage(GetDlgItem(hMainWnd, IDC_DEBUG), EM_SCROLLCARET, 0, 0);

	RedrawWindow(GetDlgItem(hMainWnd, IDC_DEBUG), NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);

	return;
}

void LogHex(DWORD data)
{
	BYTE buf[9];

	wsprintf(buf, "%02X", data);
	Log(buf);

	return;
}

BOOL SetBaudrate(HANDLE hcom, DWORD rate)
{
	DCB dcb;
	BOOL result;

	ZeroMemory(&dcb, sizeof(dcb));
	dcb.DCBlength = sizeof(dcb);
	GetCommState(hcom, &dcb);

	dcb.BaudRate = CBR_600;

	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
	result = SetCommState(hcom, &dcb);
	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);

	return result;
}

// sub routine //
BOOL ChangeBaudrate(HANDLE hcom, DWORD rate)
{
	unsigned char buf[32];

	// ChangeSpeed...?

	buf[0] = 0x02;
	buf[1] = 0x00;
	buf[2] = 0x00;
	buf[3] = 0x00;
	buf[4] = 0x01;
	buf[5] = 0x00;
	buf[6] = 0x00;

	if(sendCommand(hcom, buf, 7))
	{
		Log("CB1 Write failed\r\n");
		return TRUE;
	}
	if(ReadByte(hcom) != 0x06)
	{
		Log("CB1 FAILED\r\n");
		return TRUE;
	}

	buf[0] = 0x02;
	buf[1] = 0x00;
	buf[2] = 0x01;
	buf[3] = (unsigned char)(rate >> 24) & 0xFF;
	buf[4] = (unsigned char)(rate >> 16) & 0xFF;
	buf[5] = (unsigned char)(rate >> 8) & 0xFF;
	buf[6] = (unsigned char)rate & 0xFF;

	if(sendCommand(hcom, buf, 7))
	{
		Log("CB2 Write failed\r\n");
		return TRUE;
	}
	if(ReadByte(hcom) != 0x06)
	{
		Log("CB2 FAILED\r\n");
		return TRUE;
	}

	SetBaudrate(hcom, rate);

	// ㏈?
	buf[0] = 0x02;
	buf[1] = 0x00;
	buf[2] = 0x03;
	buf[3] = 0x00;
	buf[4] = 0x00;
	buf[5] = 0x10;
	buf[6] = 0x00;

	if(sendCommand(hcom, buf, 7))
	{
		Log("CB3 Write failed\r\n");
		return TRUE;
	}
	if(ReadByte(hcom) != 0x06)
	{
		Log("CB3 FAILED\r\n");
		return TRUE;
	}

	return FALSE;
}

BOOL getTelNo(HANDLE hcom)
{
	unsigned char buf[32], tmp[32];
	int i;
	DWORD bytes;

	if(WriteByte(hcom, 0x8E))
	{
		Log("ERROR: GTN Write failed\r\n");
		return TRUE;
	}
	for(i = 0;;)
	{
		ReadFile(hcom, buf, 1, &bytes, NULL);
		if(!bytes)
			continue;
		if(buf[0] == 0xAA)	// End of Number
			break;
		if(buf[0] == 0x9A)
			buf[0] = 0x90;
		if(0x90 <= buf[0] && buf[0] <= 0x99)
		{
			tmp[i] = buf[0] - 0x90 + '0';
			i += bytes;
		}
	}

	//Log(tmp);
	SetDlgItemText(hMainWnd, IDC_TELNO, tmp);
	Log("OK");

	return FALSE;
}

HANDLE StartSerialTransfer(LPCTSTR comport)
{
	HANDLE hcom;

	if((hcom = CreateFile(comport, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
		return NULL;

	// Setup Buffer Size
	SetupComm(hcom, 4096, 4096);

	// Set TimeOut
	{
		COMMTIMEOUTS cto;

		cto.ReadIntervalTimeout = 10;
		cto.ReadTotalTimeoutMultiplier = 1;
		cto.ReadTotalTimeoutConstant = 100;
		cto.WriteTotalTimeoutMultiplier = 1;
		cto.WriteTotalTimeoutConstant = 100;
		SetCommTimeouts(hcom, &cto);
	}

	// Set BaudRate, StopBits, BitSize, Parity....
	{
		DCB dcb;

		ZeroMemory(&dcb, sizeof(dcb));
		dcb.DCBlength = sizeof(dcb);
		GetCommState(hcom, &dcb);

		dcb.StopBits = ONESTOPBIT;
		dcb.fParity = TRUE;
		dcb.Parity = EVENPARITY;
		dcb.ByteSize = 8;

		dcb.EofChar = 0;
		dcb.ErrorChar = 0;
		// what is brk?
		dcb.fErrorChar = TRUE;	// needed?
		dcb.EvtChar = 0;
		dcb.XonChar = 0;
		dcb.XoffChar = 0;

		dcb.XoffLim = 0;
		dcb.XonLim = 0;
		SetCommState(hcom, &dcb);
	}

	SetBaudrate(hcom, 600);	// 600ċ@Ƃ̌݊?mȂB

	// need?
	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);

	return hcom;
}

BOOL ChangeMode(HANDLE hcom)
{
	BYTE buf[4];

retry:
	// Mode change?
	buf[0] = 0xD0;
	buf[1] = 0x01;
	buf[2] = 0x05;
	if(Write(hcom, buf, 3))
	{
		Log("D00105 Write Failed\r\n");
		return TRUE;
	}
	buf[2] = 0x06;
	{
		DWORD c = 0;
		WORD rb;

		while(c < 3)
		{
			if((rb = ReadByte(hcom)) == 0x0100)
			{
				Log("D00105 phase Read Failed\r\n");
				return TRUE;
			}
			if(rb & 0xF0 == 0xC0)	// it is antenna level
				continue;
			if(rb == 0x08)
			{
				Log("Retrying...");
				goto retry;
			}
			if(buf[c] != rb)
			{
				Log("D00105 phase Mismatch(");
				LogHex(rb);
				Log(")\r\n");
				return TRUE;
			}
			c++;
		}
	}
	// here, will not come 0xC* data(antenna level) NO LONGER??

	buf[0] = 0x05;
	if(Write(hcom, buf, 1))
	{
		Log("05 Write Failed\r\n");
		return TRUE;
	}
	if(Read(hcom, buf, 1))
	{
		Log("05 Read Failed\r\n");
		return TRUE;
	}
	if(buf[0] != 0x06)
	{
		Log("05 Data Error RET=");
		LogHex(buf[0]);
		Log("\r\n");
		return TRUE;
	}

	return FALSE;
}

BOOL EndSerialTransfer(HANDLE hcom)
{
	Log("EOT ");
	if(WriteByte(hcom, 0x04))
	{
		Log("Write failed\r\n");
		CloseHandle(hcom);
		return TRUE;
	}
	Log("sent.\r\n");

	// Ô
	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);

	CloseHandle(hcom);

	return FALSE;
}

void doSomething(void)
{
	HANDLE hcom;
	char port[16];
	DWORD baud;

	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);

	Log("<<GetInfo>>\r\n");
	Log("COM open...");
	if(!(hcom = StartSerialTransfer(port)))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	// do peer to peer!!
	{
		unsigned char buf[256];	// @擾Ƃover ΁[
		WORD pktlen;

		Log("GetTelNo...");
		if(getTelNo(hcom))
		{
			CloseHandle(hcom);
			return;
		}
		Log("\r\n");

		Log("ChangeMode...");
		if(ChangeMode(hcom))
		{
			CloseHandle(hcom);
			return;
		}
		Log("OK\r\n");

		Log("ChangeBaud...");
		if(ChangeBaudrate(hcom, baud))
		{
			CloseHandle(hcom);
			return;
		}
		Log("OK\r\n");

		Log("GetProfile(0000h)...");
		buf[0] = 0x02;
		buf[1] = 0x02;
		buf[2] = 0x04;
		buf[3] = 0x00;	// 0000h
		buf[4] = 0x00;
		if(sendCommand(hcom, buf, 5))
		{
			Log("Send failed\r\n");
			CloseHandle(hcom);
			return;
		}
		if(Read(hcom, buf, 1))
		{
			Log("Read return failed\r\n");
			CloseHandle(hcom);
			return;
		}
		if(buf[0] != 0x06)
		{
			Log("NOT ACK\r\n");
			WriteByte(hcom, 0x04);
			CloseHandle(hcom);
			return;
		}
		if(Read(hcom, buf, 2))
		{
			Log("Read head failed\r\n");
			CloseHandle(hcom);
			return;
		}
		if(buf[0] != 0x01 || buf[1] != 0x80)
		{
			Log("Illegal head\r\n");
			CloseHandle(hcom);
			return;
		}
		if(Read(hcom, buf, 2))
		{
			Log("Read length failed\r\n");
			CloseHandle(hcom);
			return;
		}
		pktlen = (buf[0] << 8) + buf[1];
		if(Read(hcom, buf, pktlen))
		{
			Log("Read data failed\r\n");
			CloseHandle(hcom);
			return;
		}
		if(WriteByte(hcom, 0x06))
		{
			Log("ACK Write failed\r\n");
			CloseHandle(hcom);
			return;
		}
		Log("Set...");
		{
			BYTE buf2[32];
			DWORD i = 1;

			// skip types? data
			i += ((buf[1] << 8) | buf[2]) * 2 + 2 + 1;

			strnncopy(buf2, buf + i + 1, buf[i] + 1);
			SetDlgItemText(hMainWnd, IDC_MANUFACTURE, buf2);
			i += buf[i] + 2;
			strnncopy(buf2, buf + i + 1, buf[i] + 1);
			SetDlgItemText(hMainWnd, IDC_MODEL, buf2);
			i += buf[i] + 2;
		}
		Log("OK\r\n");
	}

	if(EndSerialTransfer(hcom))
		return;

	Log("Close connection nicely.\r\n");

	return;
}

void checkLockNo(void)
{
	BYTE buf[16];
	HANDLE hcom;

	char port[16];
	DWORD baud;

	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);

	Log("<<Check Lock No>>\r\n");
	Log("COM open...");
	if(!(hcom = StartSerialTransfer(port)))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	Log("ChangeMode...");
	if(ChangeMode(hcom))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	Log("ChangeBaud...");
	if(ChangeBaudrate(hcom, baud))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	Log("CheckLockNo...");
	buf[0] = 0x02;
	buf[1] = 0x00;
	buf[2] = 0x21;
	GetDlgItemText(hMainWnd, IDC_LOCKNO, buf + 3, 9);
	if(sendCommand(hcom, buf, GetDlgItemTextLength(hMainWnd, IDC_LOCKNO) + 3))
	{
		Log("ERROR: CLN Send ERR\r\n");
		CloseHandle(hcom);
		return;
	}
	if(Read(hcom, buf, 1))
	{
		Log("ERROR: CLN Read ERR\r\n");
		CloseHandle(hcom);
		return;
	}
	switch(buf[0])
	{
	case 0x06:
		Log("NICE\r\n");
		break;
	case 0x18:
		Log("BAD\r\n");
		break;
	default:
		Log("UNKNOWN CODE ");
		{
			char tmp[3];
			wsprintf(tmp, "%02X", buf[0]);
			Log(tmp);
			Log("\r\n");
		}
	}

	if(EndSerialTransfer(hcom))
		return;

	Log("Close connection nicely.\r\n");
}

BOOL GetDlgItemChecked(HWND hDlg, int nIDDlgItem)
{
	if(SendMessage(GetDlgItem(hDlg, nIDDlgItem), BM_GETCHECK, 0, 0) & BST_CHECKED)
		return TRUE;
	else
		return FALSE;
}

void searchLockNo(void)
{
	BYTE buf[16];
	HANDLE hcom;

	char port[16];
	DWORD baud;
	BOOL longmode;

	DWORD number;

	DWORD starttime, endtime;

	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);
	longmode = GetDlgItemChecked(hMainWnd, IDC_LNLONG);

	Log("<<Search Lock No>>\r\n");
	if(longmode)
		Log("(Long mode)\r\n");
	Log("COM open...");
	if(!(hcom = StartSerialTransfer(port)))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	Log("ChangeMode...");
	if(ChangeMode(hcom))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	Log("ChangeBaud...");
	if(ChangeBaudrate(hcom, baud))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	starttime = GetTickCount();

	// ĂlX^[g
	number = GetDlgItemInt(hMainWnd, IDC_LOCKNO, NULL, FALSE);

	Log("Searching\r\n");
	if(!longmode)
	{
		for(; number <= 9999; number++)
		{
			if(number % 100 == 0)
			{
				wsprintf(buf + 3, "%04d", number);
				SetDlgItemText(hMainWnd, IDC_LOCKNO, buf + 3);
				RedrawWindow(GetDlgItem(hMainWnd, IDC_LOCKNO), NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
				if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
				{
					number = 10001;
					break;
				}
			}

			buf[0] = 0x02;
			buf[1] = 0x00;
			buf[2] = 0x21;
			wsprintf(buf + 3, "%04d", number);

			if(sendCommand(hcom, buf, 3 + 4))
			{
				Log("ERROR: CLN Send ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(Read(hcom, buf, 1))
			{
				Log("ERROR: CLN Read ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(buf[0] == 0x06)
				break;		// YES!!
			if(buf[0] == 0x18)
				continue;	// Bad

			Log("UNKNOWN CODE ");
			{
				char tmp[3];
				wsprintf(tmp, "%02X", buf[0]);
				Log(tmp);
				Log("\r\n");
			}
		}

		endtime = GetTickCount();

		// Translate
		if(number == 10000)
			number = 100000000;
		if(number == 10001)
			number = 100000001;
	}else
	{	// LongMode
		Log("(Longmode: slow)\r\n");

		for(; number <= 99999999; number++)
		{
			if(number % 1000 == 0)
			{
				wsprintf(buf + 3, "%04d", number);
				SetDlgItemText(hMainWnd, IDC_LOCKNO, buf + 3);
				RedrawWindow(GetDlgItem(hMainWnd, IDC_LOCKNO), NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
				if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
				{
					number = 100000001;
					break;
				}
			}

			buf[0] = 0x02;
			buf[1] = 0x00;
			buf[2] = 0x21;
			wsprintf(buf + 3, "%04d", number);

			if(sendCommand(hcom, buf, 3 + strlength(buf + 3)))
			{
				Log("ERROR: CLN Send ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(Read(hcom, buf, 1))
			{
				Log("ERROR: CLN Read ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(buf[0] == 0x06)
				break;		// YES!!
			if(buf[0] == 0x18)
				continue;	// Bad

			Log("UNKNOWN CODE ");
			{
				char tmp[3];
				wsprintf(tmp, "%02X", buf[0]);
				Log(tmp);
				Log("\r\n");
			}
		}
		endtime = GetTickCount();
	}

	if(number <= 99999999)
	{
		Log("Found: YOU GOT IT!\r\n");
		SetDlgItemInt(hMainWnd, IDC_LOCKNO, number, FALSE);
	}
	if(number == 100000000)
	{
		SetDlgItemText(hMainWnd, IDC_LOCKNO, "");
		if(longmode)
			Log("Not found: what happened..?\r\n");
		else
			Log("Not found: try longmode please.\r\n");
	}
	if(number == 100000001)
		Log("Stop: Escaped by user.\r\n");

	{
		char msg[80];
		wsprintf(msg, "Elapsed time: %u ms.\r\n", endtime - starttime);
		Log(msg);
	}

	if(EndSerialTransfer(hcom))
		return;

	Log("Close connection nicely.\r\n");
}

BOOL CALLBACK FilesWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0);
		break;
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:
			switch(LOWORD(wParam))
			{
			case IDOK:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			}
		}
		break;
	}

	return FALSE;
}

void getFiles(void)
{
	HWND hfw;
	HANDLE hcom;
	char port[16];
	DWORD baud;

	Log("<<GetFiles>>\r\n");

	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);

	Log("COM open...");
	if(!(hcom = StartSerialTransfer(port)))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	Log("ChangeMode...");
	if(ChangeMode(hcom))
	{
		Log("failed\r\n");
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	Log("ChangeBaud...");
	if(ChangeBaudrate(hcom, baud))
	{
		Log("failed\r\n");
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	hfw = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_FILESDIALOG), hMainWnd, FilesWndProc);
	ShowWindow(hfw, SW_SHOW);

	Log("Close connection ");
	if(EndSerialTransfer(hcom))
	{
		Log("illegally!\r\n");
		return;
	}

	Log("nicely.\r\n");

	return;
}

// Handler //
BOOL CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		hMainWnd = hWnd;

		SetWindowText(hWnd, "KMprototype 4 au Keitai");
		{
			HICON hi = LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
			SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hi);
			DestroyIcon(hi);
		}
		{
			HICON hi = LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
			SendMessage(hWnd, WM_SETICON, ICON_BIG, (LPARAM)hi);
			DestroyIcon(hi);
		}

		SetDlgItemText(hWnd, IDC_PORT, "COM5");
		SetDlgItemInt(hWnd, IDC_BAUDRATE, /*115200*/230400, FALSE);

		return TRUE;	// set default focus
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		break;
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0);
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:
			switch(LOWORD(wParam))
			{
			case IDOK:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			case IDC_RUN:
				doSomething();
				break;
			case IDC_LNCHECK:
				checkLockNo();
				break;
			case IDC_LNSEARCH:
				searchLockNo();
				break;
			case IDC_FILES:
				getFiles();
				break;
			case IDC_DEBUGCLEAR:
				SetDlgItemText(hWnd, IDC_DEBUG, "");
				break;
			case IDC_APPICON:
				{
					char name[MAX_PATH + 1];
					char* vi;
					DWORD size;

					GetModuleFileName(NULL, name, MAX_PATH);
					size = GetFileVersionInfoSize(name, 0);
					if(vi = halloc(size))
					{
						GetFileVersionInfo(name, 0, size, vi);
						{
							VS_FIXEDFILEINFO* ver = (VS_FIXEDFILEINFO*)(vi + 40);

							// nameg
							wsprintf(name, "KM Version %d.%d.%d.%d", HIWORD(ver->dwFileVersionMS), LOWORD(ver->dwFileVersionMS),
																HIWORD(ver->dwFileVersionLS), LOWORD(ver->dwFileVersionLS));
							MessageBox(hWnd, name, "About KM", MB_ICONASTERISK | MB_OK);
						}
						hfree(vi);
					}
				}
				break;
			}
			break;
		}
		break;
	}

	return FALSE;
}

// main routine //
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, MainWndProc, 0);

	ExitProcess(0);
}
